#! /fs/local/bin/perl

$TabData = "DATA_TABLE" ;
$TypeName = "MyType" ;
$TypePrefix = "MyT_" ;
$TailStr = "" ; 

while(<>) {
    if(($tmp) = /^\:DATATAB\s*\=\s*([A-Za-z0-9_]+)/) {
	$TabData = $tmp ;
	next ;
    } ;
    if(($tmp) = /^\:TYPENAME\s*\=\s*([A-Za-z0-9_]+)/) {
	$TypeName = $tmp ;
	next ;
    } ;
    if(($tmp) = /^\:TYPEPREFIX\s*\=\s*([A-Za-z0-9_]+)/) {
	$TypePrefix = $tmp ;
	next ;
    } ;
    if(($tmp) = /^\:INSERT\s*([^\s]+)/) {
	$EndMark = $tmp ;
	while(<>) {
	    /$EndMark/ && do { last ; } ;
	    print ;
	} ;
    } ;
    if(($tmp) = /^\:TAIL\s*([^\s]+)/){ 
	$EndMark = $tmp ;
	while(<>) {
	    /$EndMark/ && do { last ; } ;
	    $TailStr .= $_ ;
	} ;
    }
    if(!/^\"/) { next ; } ;

    chop ;
    ($name,$rest) = /^(\".*\")\s*(.*)$/ ;
    $name =~ s/\"//g ;
    push(@namelist, $name) ;
    push(@restlist, $rest) ;
}

printf "\ntypedef enum \{\n" ;
for($i = 0 ; $i <= $#namelist ; $i++) {
    $tname = $namelist[$i] ;
    $tname =~ s/ /_/g ;
    printf "\t%s%s,\n",$TypePrefix,$tname ;
} ;
printf "\t%s\_MAX\n\} %s ;\n", $TypePrefix,$TypeName ;

printf "\n#define %s\t\{\\\n",$TabData ;
for($i = 0 ; $i <= $#namelist ; $i++) {
    $tname = $namelist[$i] ;
    $tname =~ s/ /_/g ;
    if($restlist[$i]) {
	printf "  \{\"%s\", %s%s, %s\},\\\n",
	  $namelist[$i],$TypePrefix,$tname,$restlist[$i] ;
    } else {
	printf "  \{\"%s\", %s%s\},\\\n",
	$namelist[$i],$TypePrefix,$tname ;
    } ;
} ;
printf "  \{NULL\}\}\n" ;

if($TailStr) {
    print "\n\n" ;
    print $TailStr ;
}



    

