/*
  SKILLS : HEADER FILE
  
  Dribling skills: 
    find the best dribble direction
    dribble in that direction

  Mehran Motamed
  Ehsan Foroughi 

  ParsAI Team
  Sharif University of Tech.

 */

#ifndef _DRIBBLE_MOVE_H
#define _DRIBBLE_MOVE_H

#ifndef _skills_dribble_extern_
#define _skills_dribble_extern_ extern
#endif

#include "../headers.h"


class c_dribble: public c_base_skill
{
 public:
  c_dribble(void);
  void   update_bytime(void);
  void   set_dest(double x, double y);
  bool   possible(void);
  double weight(void);
  void   perform(void);

 protected:
  void    find_best_dribble_direction(void);
  void    calculate(void);
  void    spiral_dribble(int num);
  double  cone_val(double dir);
  int     too_close_opp(double dir);

  double  best_direction;
  int     dribble_case;
  double  destx, desty;
  double  maxpower;
  double  value;  
  bool    calculated;
  Command com2send;
};

_skills_dribble_extern_ c_dribble dribble;

_skills_dribble_extern_ int last_dribble_time;

#endif

