/*
  SKILLS : HEADER FILE
  
  Moving skills: 
    move to a location
    go get the ball !
    goto playing post

  Ehsan Foroughi 

  ParsAI Team
  Sharif University of Tech.

 */

#ifndef _SKILLS_MOVE_H
#define _SKILLS_MOVE_H

#define BLOCKING_DIST      1.50
#define TEAM_MATES_BLOCK   true
#define PASS_BLOCK_ANGLE   40.0
#define BLOCKING_BALL_DIST 8.0

#define STAND_RANGE        4.0
#define NEAR_OPP_RANGE     1.0

#ifndef _skills_move_extern_
#define _skills_move_extern_ extern
#endif

#include "../headers.h"

class c_move_utils
{
 public:
  int least_turns_needed_2move(double length);
  c_move_utils(void) {calculated = false;};
 protected:
  void calculate(void);
  bool calculated;
  int mlar[(int)(FIELD_LENGTH)*4];
};

class c_move_skills: public c_base_skill
{
 public:
  void move_2dest(Command &com, double x, double y, double maxdash);
  int who_controls_ball(void);
  int can_get2ball_fastest(void);
 protected:
  int turns_needed_2get2loc(double x, double y, double maxdash);
  int least_turns_needed_2move(double length, double iv, double dashpw);
  int ballturns_2get_mostnear(double maxdash);
  int way_blocked(double x, double y);

  int blocking_unum;
  bool is_passing_block;
};

class c_get_2ball: public c_move_skills
{
 public:
  void update_bytime(void);
  bool possible(void);
  double weight(void);
  void perform(void);

  int needed_turns(void);

 protected:
  void calculate(void);

  double maxdash;
  int turns;
  Command com2send;
};

class c_goto_playing_post: public c_move_skills
{
 public:
  void update_bytime(void);
  bool possible(void);
  double weight(void);
  void perform(void);
 protected:
  void calculate(void);

  void calc_dest(void);

  void calc_pos(void);

  double land_value(double x, double y);
  double position_in_field_value(double x, double y);
  double standing_position_value(double x, double y);
  double opponents_value(double x, double y);
  double offside_value(double x, double y);

  double destx;
  double desty;

  Command com2send;
};

_skills_move_extern_ c_move_utils move_utils;

_skills_move_extern_ c_get_2ball get_2ball;

_skills_move_extern_ c_goto_playing_post goto_playing_post;

#endif
