// increase MAX_PASS_RADIUS if DoubleKick is used by Pass! :O
// dedicating backpass only to pass within penalty area.......Done.
// the change should be fully debugged! the values' range should
// approximately be known in order to see when to pass backward (when
// the value become greater than a constant)

#define _skills_pass_extern_
#include "pass.h"

void c_pass::update_bytime(void)
{
  com2send.type = NO_COMMAND;
  calculated = false;
  value = 0;
}

bool c_pass::possible(void)
{
  if (!calculated) calculate();
  return (canpass);
}

double c_pass::weight(void)
{
  if (!calculated) calculate();
  return value;
}

void c_pass::perform(void)
{
  if (!calculated) calculate();
  
  if (!canpass) {
    logmsg("Error in calling pass skill, Unable to perform skill!");
    return;
  };

  if ((LOGIT)&&(LOG_SKILL)) {
    fprintf(client.log.file, "\nLogging Skills state in time %d :", world.time.clock);
    fprintf(client.log.file, "\n  Skill : Passing skill acting.");
    fprintf(client.log.file, "\n    Passing to player %d\n", dest_player);
  };

  perform_command(com2send);
  sensor.comm.sth2say = true;
  sensor.comm.passdest = dest_player;
}

double c_pass::position_in_field_value(int num)
{
  double return_value;
  double d;
  double rx=36,ry=30;
  
  d = dist(world.tmate[num].x/rx,world.tmate[num].y/ry);
  return_value=100-fabs(1-d)*40;
  if (return_value>100) return_value = 100;
  if (return_value<30) return_value = 30;
  return_value*=(world.tmate[num].x+FIELD_LENGTH/2)/FIELD_LENGTH;
  if (return_value>100) return_value=100;
  if (return_value<0) return_value=0;
  return return_value;
}

double c_pass::position_value(int num)
{
  int i;
  double dist_opp_2me,dist_tmate_2me;
  double val;
  double opp_value   = 100;
  double tmate_value = 10;
  double field_value; 
  
  for(i=1;i <= N_PLAYER_PER_TEAM;i++) {
    dist_opp_2me = dist_2me(world.opp[i].x,world.opp[i].y);
    if (dist_opp_2me < POS_VAL_RANGE_RAD) {
      opp_value = opp_value * ((dist_opp_2me+POS_VAL_RANGE_RAD)/2) / POS_VAL_RANGE_RAD;
      if (world.opp[i].x > world.body.loc.x) opp_value = 0.9*opp_value;
    }
    if (i!=num) {
      dist_tmate_2me = dist_2me(world.tmate[i].x,world.tmate[i].y);
      if (dist_tmate_2me < POS_VAL_RANGE_RAD) {
        tmate_value = (100 - (100 - tmate_value) * ((dist_tmate_2me+POS_VAL_RANGE_RAD)/2) / POS_VAL_RANGE_RAD);
        if (world.tmate[i].x < world.body.loc.x) tmate_value = 0.9*tmate_value;
      }
    }    
  }
  field_value = position_in_field_value(num);
  val = ( 0.4*field_value + 0.5*opp_value + 0.1*tmate_value );
  return val;
}


double c_pass::safeness_value(int num, double sx, double sy)
{
  double safe_val=100;
  double tmate2ball;
  double angle2tmate;
  double angle2opp;
  double angle_dif;
  double opp2ball;
  double ratio;
  int i;                     	

  tmate2ball  = dist(world.tmate[num].x-sx,world.tmate[num].y-sy);
  angle2tmate = direction(world.tmate[num].x-sx,world.tmate[num].y-sy);
  for(i=1;i <= N_PLAYER_PER_TEAM;i++) {
    if (dist(world.opp[i].x-sx,world.opp[i].y-sy)<tmate2ball) {
      opp2ball = dist2point(sx,sy,world.opp[i]);
      ratio = opp2ball/tmate2ball;
      angle2opp = direction(world.opp[i].x-sx,world.opp[i].y-sy);
      angle_dif = fabs(angle2tmate-angle2opp);
//      if (angle_dif<30) safe_val = safe_val * ((angle_dif+30)/2)/30;
      if (angle_dif<30)
        safe_val = safe_val * ((angle_dif+30)/2)/30 * ratio + safe_val * (1-ratio);
    }
  }
  return safe_val;
}

double c_pass::forepass_value(int num)
{ 
  double fp_val;
  double safe_val;
  double pos_val;
  double loc_val;
  double my_posval;
  double tmate2ball;
  int q;

  tmate2ball  = dist2point(world.tmate[num].x,world.tmate[num].y,world.ball);
  // evaluating pass' safeness value ...
  safe_val = safeness_value(num,world.ball.x,world.ball.y);
//  if (safe_val<63) return 1;
  // evaluating teammate's position value ...
  pos_val = position_value(num);
  // evaluating teammate's relative location value ...
  if (tmate2ball<20) q=-180; else q=-630;
  loc_val = world.tmate[num].correctness*(q/Pow(MAX_PASS_RADIUS-MIN_PASS_RADIUS)*Pow(tmate2ball-(0.66*(MAX_PASS_RADIUS-MIN_PASS_RADIUS)+MIN_PASS_RADIUS))+100)/100;	 
  // evaluating final forepass value to player <num>  ...
  fp_val = 0.35*safe_val + 0.55*pos_val + 0.10*loc_val; 
  my_posval = position_value(player.unum);
  if (my_posval>pos_val) fp_val = 0.75*fp_val;
  if ((LOGIT)&&(LOG_SKILL)&&(DEBUG_MODE)) {
    fprintf(client.log.file, "\n Foreward Pass to player %d",num);
    fprintf(client.log.file, "\n   -- safeness value : %.2f",safe_val);
    fprintf(client.log.file, "\n   -- position value : %.2f",pos_val);
    fprintf(client.log.file, "\n   -- location value : %.2f",loc_val);
    fprintf(client.log.file, "\n   -- my pos.  value : %.2f",my_posval);
    fprintf(client.log.file, "\n   ** Final forepass value ---> %.2f",fp_val);
  };
  return fp_val; 
}

double c_pass::backpass_value(int num)
{
  double bp_val;
  double safe_val;
  double pos_val;
  double loc_val;
  double my_posval;
  double tmate2ball;
  double angle2tmate;
  int q;

  return 1;

  tmate2ball  = dist2point(world.tmate[num].x,world.tmate[num].y,world.ball);
  // evaluating pass' safeness value ...
  safe_val = safeness_value(num,world.ball.x,world.ball.y);
//  if (safe_val<50) return 1; 
  // evaluating teammate's position value ...
  pos_val = position_value(num);
  // evaluating teammate's relative location value ...
//  loc_val = 0;
//  if (world.tmate[num].x>26) {
    angle2tmate = direction(world.tmate[num].x-world.ball.x,world.tmate[num].y-world.ball.y); 
    if (tmate2ball<20) q=-180; else q=-630;
    loc_val = world.tmate[num].correctness*(q/Pow(MAX_PASS_RADIUS-MIN_PASS_RADIUS)*Pow(tmate2ball-(0.66*(MAX_PASS_RADIUS-MIN_PASS_RADIUS)+MIN_PASS_RADIUS))+100)/100;	 
//    loc_val = loc_val*(fabs(world.tmate[num].y)+FIELD_WIDTH/2)/FIELD_WIDTH;//dist from X axis
//    loc_val = loc_val*world.tmate[num].x/(FIELD_LENGTH/2); //dist from Y axis
    loc_val = loc_val*(0.5+cos(Deg2Rad(angle2tmate))); // angle 
//    loc_val = (loc_val+100)/200; // restoring the value :P
//  }
  // evaluating final forepass value to player <num>  ...
  bp_val = 0.20*safe_val + 0.20*pos_val + 0.60*loc_val;
  my_posval = position_value(player.unum);
  if (my_posval>pos_val) bp_val = 0.75*bp_val;
  if ((LOGIT)&&(LOG_SKILL)&&(DEBUG_MODE)) {
    fprintf(client.log.file, "\n Backward Pass to player %d",num);
    fprintf(client.log.file, "\n   -- safeness value : %.2f",safe_val);
    fprintf(client.log.file, "\n   -- position value : %.2f",pos_val);
    fprintf(client.log.file, "\n   -- location value : %.2f",loc_val);
    fprintf(client.log.file, "\n   -- my pos.  value : %.2f",my_posval);
    fprintf(client.log.file, "\n   ** Final backpass value ---> %.2f",bp_val);
  };
  return bp_val;
}

int c_pass::best_pass_target(void) 
{
  int    best_fplayer=player.unum;
  int    best_bplayer=player.unum;
  double fpass_value=0,bpass_value=0;
  double last_fpass_val=0,last_bpass_val=0;
  double tmate2ball;
  double angle2tmate;
  int    i;

  for(i=1;i <= N_PLAYER_PER_TEAM;i++) {
    tmate2ball = dist2point(world.tmate[i].x,world.tmate[i].y,world.ball);
    if ((i!=player.unum)
       &&(tmate2ball<MAX_PASS_RADIUS)
       &&(tmate2ball>MIN_PASS_RADIUS)
       &&(world.tmate[i].correctness>MIN_USEFUL_CRR)) { 

      angle2tmate = direction(world.tmate[i].x-world.ball.x,world.tmate[i].y-world.ball.y);
      if (fabs(angle2tmate)<80) {
        fpass_value = forepass_value(i);
        if (i==1) fpass_value = GOALER_PASS_FACTOR*fpass_value; 
        if (world.tmate[i].x>world.offside.opp.line) fpass_value /= Pow(fabs(world.body.loc.x - world.offside.opp.line) + 1);
      } else if ((fabs(angle2tmate)<120)&&(world.tmate[i].x>26)){ 
        bpass_value = backpass_value(i); 
        if (i==1) bpass_value = GOALER_PASS_FACTOR*bpass_value; 
        if (world.tmate[i].x>world.offside.opp.line) bpass_value /= Pow(fabs(world.body.loc.x - world.offside.opp.line) + 1);
      }
      if (fpass_value > last_fpass_val) {
        last_fpass_val = fpass_value;
        best_fplayer = i;
      }
      if (bpass_value > last_bpass_val) {
        last_bpass_val = bpass_value;
        best_bplayer = i;
      }
    }
  } 
  if (world.body.stamina<800) {
    fpass_value = bpass_value = 100;
  } else if (world.body.stamina<1800) {
    fpass_value = fpass_value*(1800/world.body.stamina);
    bpass_value = bpass_value*(1800/world.body.stamina);
  }
    
  if ((LOGIT)&&(LOG_SKILL)) {
    fprintf(client.log.file,"\n  ** Final forepass value ---> %.2f",fpass_value);
    fprintf(client.log.file,"\n  ** Final backpass value ---> %.2f",bpass_value);
  }

  int pass_min_val = 36;
//  if ((player.unum==4)||(player.unum==5)) pass_min_val = 18;
//  else if (client.role==DEFEND) pass_min_val = 25;*/
 
  // the number, (XX), is a matter of taste !!! :)
  if (fpass_value>pass_min_val) {
      value = fpass_value;
      return best_fplayer; 
  } else if // (
	       (bpass_value>32)
//	       ||((bpass_value>30)&& 
//             (free_dist_cone(direction(GOAL_X-world.body.loc.x,-world.body.loc.y))<5))) 
             {
      value = bpass_value;
      return best_bplayer; 
  } else return player.unum;
}

int c_pass::search_pass_value(double kpower, double kdir, double &reachspeed)
{
  double power_rate, rv=0;
  Objpos bl, bll;
  int ntmate=1, ttmate=60, nopp=1, topp=60, i, tr;

  bl = world.ball;

  power_rate = KICK_POWER_RATE * (1 - 0.25 * fabs(reldir_2me(world.ball))/180.0
    - 0.25 * (dist_2me(world.ball)-PLAYER_SIZE-BALL_SIZE)/KICKABLE_MARGIN);
  bl.vx += kpower*power_rate*cos(Deg2Rad(kdir+world.body.loc.body_dir));
  bl.vy += kpower*power_rate*sin(Deg2Rad(kdir+world.body.loc.body_dir));
  
  for (i=1;i<=N_PLAYER_PER_TEAM;i++) if (world.tmate[i].correctness<MIN_USEFUL_CRR) {
    bll = bl;
    tr = 0;
    while (move_utils.least_turns_needed_2move(dist(bll,world.opp[i]))>tr) {
      if (tr>topp) break;
      tr++;
      bll.x += bll.vx;
      bll.y += bll.vy;
      bll.vx *= BALL_DECAY;
      bll.vy *= BALL_DECAY;
      if (!is_in_field(bll)) break;
    };
    if (speed(bll)>1.3) tr++;
//    sprintf(debugbuf,"%d : %.2f - %.2f t %.2f - %d", i, bll.x, bll.y, dist(bll,world.opp[i]), tr);
//    logmsg(debugbuf);
    if (tr<topp) {
      topp=tr;
      nopp=is_in_field(bll)?12:i;
    };
  };
  for (i=2;i<=N_PLAYER_PER_TEAM;i++) 
    if ((i!=player.unum)&&(world.tmate[i].correctness<MIN_USEFUL_CRR)&&(true/*check offside*/)) {
      bll = bl;
      tr = 0;
      while (move_utils.least_turns_needed_2move(dist(bll,world.tmate[i]))>tr) {
        if (tr>ttmate) break;
        tr++;
        bll.x += bll.vx;
        bll.y += bll.vy;
        bll.vx *= BALL_DECAY;
        bll.vy *= BALL_DECAY;
        if (!is_in_field(bll)) break;
      };
      if (speed(bll)>1.3) tr+=2;
//      sprintf(debugbuf,"%d : %.2f - %.2f o %.2f - %d", i, bll.x, bll.y, dist(bll,world.opp[i]), tr);
//      logmsg(debugbuf);
      if (!is_in_field(bll)&&(tr<topp)) {
        topp=tr;
        nopp=12;
      }
      if (tr<ttmate) {
        ttmate=tr;
        ntmate=i;
        rv=speed(bll);
      }
  };
  
//  sprintf(debugbuf,"Spass : %.2f - %.2f - %d - %d", kpower, kdir, ntmate, nopp);
//  logmsg(debugbuf);
  dest_player = ntmate;
  reachspeed = rv;
  return(topp-ttmate);
}

void c_pass::search_pass(void)
{
  double kpower, kdir;
  int t, bt=-1;
  double bpower=0, bdir=0, val, bv=-1, rv=0;

  for (kpower=40;kpower<=100;kpower+=15)
    for (kdir=-180;kdir<180;kdir+=15) {
      t = search_pass_value(kpower,kdir,rv);
      val = diff_angle(kdir+world.body.loc.body_dir,direction(52-world.body.loc.x,-world.body.loc.y));
      if (val<60) val = 60;
      val = 180.0/(val-30) * (double)t;
      val *= 1/(fabs(rv-0.5)+1);
      if (diff_angle(kdir+world.body.loc.body_dir,direction(52-world.body.loc.x,-world.body.loc.y))>120)
        val *= 0.1;
      else if (diff_angle(kdir+world.body.loc.body_dir,direction(52-world.body.loc.x,-world.body.loc.y))>90)
        val *= 0.5;
      sprintf(debugbuf,"Spass : %.2f - %.2f - %d - %.2f", kpower, kdir, t, val);
      logmsg(debugbuf);
      if (val > bv) {
        bt = t;
        bv = val;
	bpower = kpower;
	bdir = kdir;
      }
    }
  search_pass_value(bpower,bdir,rv);
  
  if (bv>5) {
    com2send.type = KICK;
    com2send.par1 = bpower;
    com2send.par2 = bdir;
    canpass = true;
    if ((LOGIT)&&(LOG_SKILL)) {
      fprintf(client.log.file, "\nLogging Skills state in time %d :", world.time.clock);
      fprintf(client.log.file, "\n  Skill : Passing skill calculating.");
      fprintf(client.log.file, "\n    Passing to player %d\n", dest_player);
      fprintf(client.log.file, "\n    Search pass : power %.2f - dir %.2f - timediff %d - value %.2f", bpower, bdir, bt, bv);
    };
  } else {
    dest_player=0;
    canpass = false;
  };
}

void c_pass::calculate(void)  
{
  double i;

  calculated = true;
    
  if (!can_kickball()) {
    canpass = false;
    return;
  }    

  search_pass();
  return;
//  if (calculated) return;

  dest_player = best_pass_target();
  
  if (dest_player==player.unum) canpass = false;
  else {
/*    if ((value>50)&&(dist2point(world.opp[dest_player].x,world.opp[dest_player].y,world.ball)>20)&&(free_dist_circle()>4.5)) {
      canpass = true;
      double_kick.initiate(direction(world.tmate[dest_player].x-world.ball.x,world.tmate[dest_player].y-world.ball.y));
    } else {
      for (i=0;i<0.55;i=i+0.1) { 
        canpass = kick2location(com2send,world.tmate[dest_player].x,world.tmate[dest_player].y,0.6-i);
        if (canpass) break;
      }
    } */
    for (i=0;i<0.65;i=i+0.1) { 
      canpass = kick2location(com2send,world.tmate[dest_player].x,world.tmate[dest_player].y,0.8-i);
      if (canpass) break;
    }
    if ((!canpass) && (value>50) && (free_dist_circle()>2.0*KICKABLE_AREA)) {
      canpass = true;
      double_kick.initiate(direction(world.tmate[dest_player].x-world.ball.x,world.tmate[dest_player].y-world.ball.y));
    } 
  }

  if ((canpass)&&(collide(com2send))) spin_kick(com2send, dir_from_me(world.tmate[dest_player]));
//  if ((!canpass)&&(speed(world.ball)>0.3))
//    kick2velocity(com2send,0,0); 
}

int c_pass::goaler_pass(double &gx, double &gy)
{
  double bpv = -100;
  double bv, by = 0;
  int bp = 0;
  int i;

  for(i=2;i<=N_PLAYER_PER_TEAM;i++)
    if ((world.tmate[i].x<-5)&&(world.tmate[i].x>-30)) {
      bv = position_value(i);
      if (bpv<bv) {
        bpv = bv;
        bp = i;
      }
    }

  bv = -100;
  gx = -38.0;

  if (bp==0) gy=(genrand(2)==0)?-19.5:-19.5;
  else {
    for(gy=-19.9;gy<=19.9;gy+=1)
      if (bv<safeness_value(bp,gx,gy)) {
        bv = safeness_value(bp,gx,gy);
        by = gy;
      }
    gy = by;
  };

  return bp;
}
