#define _skills_shoot_extern_
#include "shoot.h"

void c_shoot2goal::update_bytime(void)
{
  com2send.type = NO_COMMAND;
  poscalculated = false;
  valcalculated = false;
}

bool c_shoot2goal::possible(void)
{
  calc_possibility();
  return can_shoot2goal;
}

double c_shoot2goal::weight(void)
{
  calc_value();
  return value;
}

void c_shoot2goal::perform(void)
{
  calc_value();

  if ((LOGIT)&&(LOG_SKILL)) {
    fprintf(client.log.file, "\nLogging Skills state in time %d :", world.time.clock);
    fprintf(client.log.file, "\n  Skill : Shooting to Goal skill acting.");
    fprintf(client.log.file, "\n    Shoot to goal Angle %.2f\n", dir);
  };

  perform_command(com2send);
}

void c_shoot2goal::calc_possibility(void)
{
  if (poscalculated) return;
  poscalculated = true;

  can_shoot2goal = false;

  if ((dist2goal(world.ball)<NORMAL_SHOOTING_R)||
      ((dist_2me(world.opp[GOALER_UNUM])<4)&&
       (world.opp[GOALER_UNUM].correctness>MIN_USEFUL_CRR)&&
       (dist2goal(world.ball)<30)))
    can_shoot2goal = true;

//  if (world.body.loc.x>GOAL_SHOOTING_X) can_shoot2goal = true;
}

void c_shoot2goal::calc_direction(int noise)
{
  double best_angle=0;
  double best_value=-100;
  double alpha_low;
  double alpha_high;
  double angle2opp;
  double i,min_weight,weight;
  int j;

  alpha_low =direction(GOAL_X-world.ball.x,GOAL_LOW_Y-world.ball.y+noise/2);
  alpha_high=direction(GOAL_X-world.ball.x,GOAL_HIGH_Y-world.ball.y-noise/2);
  for(i=alpha_low;i<=alpha_high;i+=0.2) {
    min_weight=1000-(int)fabs(i-(alpha_low+alpha_high)/2);
    for(j=1;j<=N_PLAYER_PER_TEAM;j++) { 
      angle2opp=direction(world.opp[j].x-world.ball.x,world.opp[j].y-world.ball.y);
      if (cos(Deg2Rad(i-angle2opp))>0) {
	weight=fabs(i-angle2opp);
	if (weight<min_weight) {
	  min_weight=weight;
	}
      }
    }
    if (min_weight>best_value) {
      best_value=min_weight;
      best_angle=i;
    }
  }

  dir = best_angle;
}

void c_shoot2goal::calc_value(void)
{
  calc_possibility();

  if (valcalculated) return;

  if (can_shoot2goal) {
    calc_direction(1);
    kick2direction(com2send,dir,100);
    if (collide(com2send)) spin_kick(com2send, dir);
  };
  valcalculated = true;
}   

double c_shoot2goal::best_dir(void)
{
  calc_value();
  return dir;
}

c_double_kick::c_double_kick(void)
{
  com2send.type = NO_COMMAND;
  last_kicked_time = 0;
  double_kick_inprogress = false;
}

void c_double_kick::initiate(double d)
{
  double_kick_inprogress = true;
  dir = d;
  calculated = false;

  calculated = true;
  kick2direction(com2send,dir,100);
  if (collide(com2send)) spin_kick(com2send, dir);

  perform();
}

void c_double_kick::update_bytime(void)
{
  com2send.type = NO_COMMAND;
  calculated = false;
  finished = false;
  if (!can_kickball()) double_kick_inprogress = false;
}

bool c_double_kick::possible(void)
{
  if (!calculated) calculate();
//  return double_kick_inprogress;
  return(speed(world.ball)>1.3);
}

double c_double_kick::weight(void)
{
  if (!calculated) calculate();
  return value;
}

void c_double_kick::calculate(void)
{
  double ang;

  calculated = true;

  kick2velocity(com2send,0,0);
  return;

  if (!double_kick_inprogress) return;

  ang=normalize_angle(reldir_2me(world.ball)+world.body.loc.body_dir-dir);
  if ((fabs(ang)>130)&&(fabs(ang)<175)) {
   double a,b,c,k,posx,posy;
    a=1;
    b=2*(cos(Deg2Rad(dir))*(world.ball.x-world.body.loc.x)+
         sin(Deg2Rad(dir))*(world.ball.y-world.body.loc.y));
    c=-Pow(PLAYER_SIZE+2.0*BALL_SIZE)-Pow(dist_2me(world.ball));
    if (!solve(a,b,c,k)) 
    {
      printf("ERROR! The Ball is not in KICKABLE Area?!\n");
      spin_2dir(com2send,reldir_2me(world.ball));
      return;
    };
    posx=world.ball.x+k*cos(dir);
    posy=world.ball.y+k*sin(dir);
    //if (one_cycle_kick2location(com2send,posx,posy))
    if (kick2location(com2send,posx,posy,0.3))
    {
      last_kicked_time=world.time.clock;
    }
    else 
    {
      if (speed(world.ball)>0.2)
      {
        kick2velocity(com2send,0,0);
      }	
      else
      {
        kick2velocity(com2send,dir,3.0);
        last_kicked_time=world.time.clock;
      }
    } 
  } else if (world.time.clock-last_kicked_time==1) {
    kick2velocity(com2send,dir,3.0);
    last_kicked_time=world.time.clock;
    finished = true;
  } else { 
    if (sin(Deg2Rad(dir-reldir_2me(world.ball)-world.body.loc.body_dir))>0)
    {
      double ang;
      ang=normalize_angle(dir-world.body.loc.body_dir-135-reldir_2me(world.ball));
      if (ang>90) ang=90;
      if (ang<-90) ang=-90;
      spin_to(com2send, ang+reldir_2me(world.ball),PLAYER_SIZE+2.0*BALL_SIZE);
    }
    else 
    {
      ang=normalize_angle(dir-world.body.loc.body_dir+135-reldir_2me(world.ball));
      if (ang>90) ang=90;
      if (ang<-90) ang=-90;
      spin_to(com2send, ang+reldir_2me(world.ball),PLAYER_SIZE+2.0*BALL_SIZE);
    } 
  }
  if (collide(com2send)) spin_kick(com2send, dir);
}

void c_double_kick::perform(void)
{
  if (!calculated) calculate();
  if ((LOGIT)&&(LOG_SKILL)) {
    fprintf(client.log.file, "\nLogging Skills state in time %d :", world.time.clock);
    fprintf(client.log.file, "\n  Skill : Double Kick skill acting.");
    fprintf(client.log.file, "\n    Double Kick in direction %.2f\n", dir);
  };
  perform_command(com2send);
  if (finished) double_kick_inprogress = false;
}
