#define _world_params_extern_
#include "params.h"

void get_server_params(char *s)
{
  int n;
  n = sscanf(s, "(server_param %lf %lf", 
    &(params.server.gwidth), 
    &(params.server.inertia_moment));
  skiptokens(s,n+1);
  n = sscanf(s, "%lf %lf %lf %lf %lf %lf",
    &(params.server.psize),
    &(params.server.pdecay),
    &(params.server.prand),
    &(params.server.pweight),
    &(params.server.pspeed_max),
    &(params.server.paccel_max));
  skiptokens(s,n);
  n = sscanf(s, "%lf %lf %lf %lf %lf %lf",
    &(params.server.stamina_max),
    &(params.server.stamina_inc),
    &(params.server.recover_init),
    &(params.server.recover_dthr),
    &(params.server.recover_min),
    &(params.server.recover_dec));
  skiptokens(s,n);
  n = sscanf(s, "%lf %lf %lf %lf %lf %lf",
    &(params.server.effort_init),
    &(params.server.effort_dthr),
    &(params.server.effort_min),
    &(params.server.effort_dec),
    &(params.server.effort_ithr),
    &(params.server.effort_inc));
  skiptokens(s,n);
  n = sscanf(s, "%lf %d %lf %lf %lf %lf",
    &(params.server.kick_rand),
    &(params.server.team_actuator_noise),
    &(params.server.prand_factor_l),
    &(params.server.prand_factor_r),
    &(params.server.kick_rand_factor_l),
    &(params.server.kick_rand_factor_r));
  skiptokens(s,n);
  n = sscanf(s, "%lf %lf %lf %lf %lf %lf",
    &(params.server.bsize),
    &(params.server.bdecay),
    &(params.server.brand),
    &(params.server.bweight),
    &(params.server.bspeed_max),
    &(params.server.baccel_max));
  skiptokens(s,n);
  n = sscanf(s, "%lf %lf %lf %lf %lf",
    &(params.server.dprate),
    &(params.server.kprate),
    &(params.server.kmargin),
    &(params.server.ctlradius),
    &(params.server.ctlradius_width));
  skiptokens(s,n);
  n = sscanf(s, "%lf %lf %lf %lf %lf %lf %lf %lf",
    &(params.server.maxp),
    &(params.server.minp),
    &(params.server.maxm),
    &(params.server.minm),
    &(params.server.maxnm),
    &(params.server.minnm),
    &(params.server.maxn),
    &(params.server.minn));
  skiptokens(s,n);
  n = sscanf(s, "%lf %lf %lf %lf %lf %lf",
    &(params.server.visangle),
    &(params.server.visdist),
    &(params.server.windir),
    &(params.server.winforce),
    &(params.server.winang),
    &(params.server.winrand));
  skiptokens(s,n);
  n = sscanf(s, "%lf %lf %lf %lf %d",
    &(params.server.kickable_area),
    &(params.server.catch_area_l),
    &(params.server.catch_area_w),
    &(params.server.catch_prob),
    &(params.server.goalie_max_moves));
  skiptokens(s,n);
  n = sscanf(s, "%lf %lf %d %d",
    &(params.server.ckmargin),
    &(params.server.offside_area),
    &(params.server.win_no),
    &(params.server.win_random));
  skiptokens(s,n);
  n = sscanf(s, "%d %d",
    &(params.server.say_cnt_max),
    &(params.server.SayCoachMsgSize));
  skiptokens(s,7);
  n = sscanf(s, "%d", &(params.server.half_time));
}

void get_player_params(char *s)
{
}

void get_player_types(char *s)
{
  int n, id;
  n = sscanf(s, "(player_type %d", &(id));
  skiptokens(s,n+1);
  n = sscanf(s, "%lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf",
    &(params.types[id].player_speed_max),
    &(params.types[id].stamina_inc_max),
    &(params.types[id].player_decay),
    &(params.types[id].inertia_moment),
    &(params.types[id].dash_power_rate),
    &(params.types[id].player_size),
    &(params.types[id].kickable_margin),
    &(params.types[id].kick_rand),
    &(params.types[id].extra_stamina),
    &(params.types[id].effort_max),
    &(params.types[id].effort_min));
}

void get_params(ParamInfo &param)
{
  if (param.type==PIT_ServerParam)
    get_server_params(param.info.server_param);
  else if (param.type==PIT_PlayerParam)
    get_player_params(param.info.player_param);
  else if (param.type==PIT_PlayerType)
    get_player_types(param.info.player_type);
}

void init_params(void)
{
  params.server.stamina_max = 4000;
}
